require 'Qt'
require 'rexml/document'
require 'tabel'
require 'palgaedit'
require 'pp'


class GoToCellDialog < Qt::TabWidget
  slots 'about()'

  def about
    STDERR.puts 'about'
  end
  

  def initialize(*k)
    super(*k)

    @tabs = []
    doc = File.open('Tudps.xml') do |infile|
      REXML::Document.new(infile)
    end
    REXML::XPath.each(doc, "//screen") do |screen|
      curnum = screen.attributes['num'].to_i
      title = screen.attributes['title']
      container = REXML::XPath.first(screen, 'container')
#      STDERR.puts "Screen: #{curnum} #{container ? container.name : ''}"
      widget = nil
      if container
        widget = addContainer(container)
      else
        widget = addTerminalImage(screen, curnum)
      end
      unless ( 'no' == screen.attributes['visable'] || widget.nil?)
        addTab(widget, title)
## uncomment the next line to keep a reference to the main widgets
        @tabs << widget
      end
      tabBar.installEventFilter(self)
    end
  end
  
  def checkcells(r, c1, c2)
#    STDERR.puts("#{@rnum} #{r} #{c1} #{c2}")
    (c1 .. c2).each do |i|
      if @cells[r][i]
        STDERR.puts "Overlap #{r} #{i} #{@cells[r][i]}: #{@el}"
        raise 'overlap'
      end
      @cells[r][i] = @rnum
    end
    [r, r, c1, c2]
  end
        
  
  def addTerminalImage(screen, curnum)
    widget = Qt::Widget.new
    scr = Qt::GridLayout.new(widget, 25, 80)
    @cells = Array.new(25)
    25.times do |i|
      @cells[i] = Array.new(80)
    end
    found = false
    screen.children.each do |el|
      next unless el.respond_to? :attributes
      @el = el
      next if el.name == 'container'
#        STDERR.puts el.name
      att = el.attributes
      begin
        scnum = att['scnum'].to_i
        scnum = curnum if scnum == 0
#          STDERR.puts "#{att['prompt']} #{att['scnum']} #{curnum}"
        row = att['row'].to_i
        col = att['tcol'].to_i
        last = att['rcol'].to_i
        mlen = att['leng'].to_i
        mlen = 4 if mlen == 0
        rubid = @rnum = att['rnum']
        elname = rubid.gsub(/\W/,'_')
        lastr = last + mlen
#          cw = screensw[scnum]
        if last > col
          scr.addMultiCellWidget(Qt::Label.new(att['prompt'],widget, elname),
            *checkcells( row, col, last - 1))
        end
#            STDERR.puts "#{att['prompt']} #{row} #{last} #{lastr}"
        edit = PalgaEdit.new(att, widget, elname)
#          Qt::Object.connect(edit, SIGNAL('textChanged(const QString&)'), edit, SLOT('showchange(const QString&)'))
        found = true
        if lastr > last
          scr.addMultiCellWidget(edit,
            *checkcells( row, last, lastr - 1))
        end
      rescue
        
        puts el
        raise
      end
    end
    found ? widget : nil
  end
  def addContainer(container)
    widget = ContainerGrid.new(container)
  end
  def eventFilter(obj, ev)
    if ev.is_a?(Qt::ContextMenuEvent)
      STDERR.puts obj, obj.count
#      obj.count.times do |i|
#        STDERR.puts obj.tabAt(i)
#      end
#      idx = tabBar.tabAt(ev.pos.y)
#      STDERR.puts "TAB #{idx.identifier}"
    else
      super
    end
  end
end

class PalgaWindow < Qt::MainWindow
  slots 'about()'

  def about
    STDERR.puts 'about'
  end

  def initialize
    super
    setCaption('Udps client')
    help = Qt::PopupMenu.new(self)
    menuBar.insertItem("&Help", help)
    help.insertItem("&About", self, SLOT('about()'))
    
  end
end

if $0 == __FILE__
    a = Qt::Application.new(ARGV)
#    Qt.debug_level = 2
#    Qt::Internal::setDebug(Qt::QtDebugChannel::QTDB_GC)
    main = Qt::MainWindow.new
    w = $tabw = GoToCellDialog.new(main)
    main.setCentralWidget(w)
    main.setCaption('Udps client')
    help = Qt::PopupMenu.new(main)
    main.menuBar.insertItem("&Help", help)
    help.insertItem("&About", w, SLOT('about()'))
    a.mainWidget = main
    main.dumpObjectTree
    main.show
    a.exec
end
